import _regeneratorRuntime from "@babel/runtime/regenerator";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import tdHttp from "./core";
import Interceptor from "./interceptor";
import { handleMethod, extend, awaitWrap, isType } from "../utils";

function getAdapter(params) {
  var adapter = params.adapter,
      others = _objectWithoutPropertiesLoose(params, ["adapter"]);

  var method = handleMethod(params);

  var config = _extends({}, others, {
    method: method
  });

  var hasAdapter = isType(adapter, "function");
  adapter = hasAdapter ? adapter : tdHttp[method];
  return {
    config: config,
    adapter: adapter,
    hasAdapter: hasAdapter
  };
}

var getResult = function getResult(params) {
  var _getAdapter, config, adapter, hasAdapter, data;

  return _regeneratorRuntime.async(function getResult$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _getAdapter = getAdapter(params), config = _getAdapter.config, adapter = _getAdapter.adapter, hasAdapter = _getAdapter.hasAdapter;
          _context.next = 3;
          return _regeneratorRuntime.awrap(adapter(config));

        case 3:
          data = _context.sent;
          return _context.abrupt("return", hasAdapter ? data : {
            config: config,
            data: data
          });

        case 5:
        case "end":
          return _context.stop();
      }
    }
  });
};

function xhr(handler) {
  return function http(params) {
    var result, res;
    return _regeneratorRuntime.async(function http$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _regeneratorRuntime.awrap(getResult(params));

          case 2:
            result = _context2.sent;

            if (!isType(handler, "function")) {
              _context2.next = 16;
              break;
            }

            _context2.prev = 4;
            res = handler(result);

            if (!(res instanceof Promise)) {
              _context2.next = 10;
              break;
            }

            return _context2.abrupt("return", res);

          case 10:
            return _context2.abrupt("return", Promise.resolve(res));

          case 11:
            _context2.next = 16;
            break;

          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](4);
            console.error(_context2.t0);

          case 16:
            return _context2.abrupt("return", result);

          case 17:
          case "end":
            return _context2.stop();
        }
      }
    }, null, null, [[4, 13]]);
  };
}

function Http() {
  this.interceptors = {
    request: new Interceptor(),
    response: new Interceptor()
  };
}

Http.prototype._request = function (params, handler) {
  try {
    var chain = [xhr(handler), undefined];
    var promise = Promise.resolve(params);
    this.interceptors.request.forEach(function (interceptor) {
      chain.unshift(interceptor.fulfilled, interceptor.rejected);
    });
    this.interceptors.response.forEach(function (interceptor) {
      chain.push(interceptor.fulfilled, interceptor.rejected);
    });

    while (chain.length) {
      promise = promise.then(chain.shift(), chain.shift());
    }

    return promise;
  } catch (error) {
    return Promise.reject(error);
  }
};

function createInstance() {
  var context = new Http();

  var instance = Http.prototype._request.bind(context);

  extend(instance, Http.prototype, context);
  extend(instance, context);
  return instance;
}

export default createInstance();